/* *************************************************************************
 *    File Name : 574200D.D (4M WORD-wide EPROM : Gang is NOT Supported !!)
 *    Pin num : 40-pin   (A0..A17     D0..D15)
 *    Size    : 4M (Chip end addr=3FFFF)
 *    Last Modify Date : 91. 3. 5 
 *
 * --------------------------------------------------------------------------
 *    Vpp=12.75	   Vcc=6.25    Dur=100us
 * -------------------------------------------------------------------------- 
 *    Device  :    TOSHIBA 574200D
 * ************************************************************************ */
declaration
   dataunit : byte;
   functions
      Program
      Read
      Verify
      Blank_Check
      Data_Compare
      Auto
   ;
   Manufacturers
      TOSHIBA
   ;
   Devices
      DTC574200D
   ;
   chips = A17 , A7, A6,  A5,  A4,  A3,  A2,  A1,  A0,  CE,
           GND1, OE, D0,  D8,  D1,  D9,  D2,  D10, D3,  D11,
	   Vcc , D4, D12, D5,  D13, D6,  D14, D7,  D15, GND2,
	   BYTE_:Vpp, A16, A15, A14, A13, A12, A11, A10, A9, A8
   ;
   $v2 = Vpp;
   $v1 = Vcc;
endd

/* -----------------------------------------------------------------------
 * Failf () ---> Fail address setting
 * ----------------------------------------------------------------------- */
int Failf (hwhb, hwlb, lwhb, lwlb, tmp)
int hwhb, hwlb, lwhb, lwlb, tmp;
{
int high, low;

   high = (hwhb << 8) | hwlb;
   low  = (lwhb << 8) | lwlb;

   @Fail high, low, tmp;
}
/* -----------------------------------------------------------------------
 * init () ---> Initial processing
 * ----------------------------------------------------------------------- */
int     init (vol2, vol3)
voltage vol2, vol3;
{
   @Vout 2, vol2;            /* Voltage Source #2 */
   @Vout 1, vol3;            /* Voltage Source #3 */
   @Out GND1   , @G;        /* Ground output */
   @Out GND2   , @G;
   @Delay  10  , @ms;   

   @Out D [0..15] , @W;       /* ------------------------ */
   @Out A [0..7]  , @W;       /*                          */
   @Out A [8..15] , @W;       /*   Initial Direction      */
   @Out A [16..17], @W;	      /*         Of               */	
   @Out Vcc	  , @W;	      /* ------------------------ */
   @Out BYTE_	  , @W;
   @Out CE        , @W;       
   @Out OE        , @W;       

   @Out CE       , @H;       /* Chip enable  is High */
   @Out OE       , @H;       /* Out  enable  is High */
   @Out BYTE_	 , @H;
   @Out Vcc	 , @H;

   @Out Vcc	 , @O;       /* Vcc Enable */
   @Out Vpp	 , @O;       /* Vpp Enable */
   @Delay 100	 , @us;
}
/* -----------------------------------------------------------------------
 * InitProcess () ---> Initial Buffer | Voltage source
 * ----------------------------------------------------------------------- */
int InitProcess ()
{
   if (FUNCTION != Program) init ( 5.0 , 5.0 );
   else                     init (12.5 , 6.25);
}
/* -----------------------------------------------------------------------
 * read () ---> read processing
 * ----------------------------------------------------------------------- */
int read (row)
int	row;
{
int  hwhb, hwlb, lwhb, lwlb;
int  sll, ell, slh, elh, shl, ehl;
int  tmp, tmp1, tmp2, incval;

   lwlb = lwhb = hwlb = hwhb = incval = 0;
   sll = ell = slh = elh = shl = ehl = tmp = tmp1 = tmp2 = 0;

   @Set B_HADDR, B_LADDR;
   @Out D [0..15], @Z;	/* Data Input  */
   
   if (SPLIT == 1)	incval = 1;
   else	
   {
   	@Inc	__B_START__;
   	incval = SPLIT + 1;
   }
   
   if (FUNCTION == Read ) 
   {
      @Display 26, row, "Reading...";
      @CheckSumON;
   }
   else if (FUNCTION == Verify)		@Display 26, row, "Verifying...";
   else if (FUNCTION == Blank_Check)	@Display 26, row, "Blank Checking...";
   else 			        @Display 26, row, "Data Comparing...";

   for ( hwhb=0 /* S_HWHB */ ; hwhb<=0 /* E_HWHB */; hwhb++ )
   {
      @Display 64, 9, hwhb;
      if (hwhb == S_HWHB) shl = S_HWLB;
      else                shl = 0;
      if (hwhb == E_HWHB) ehl = E_HWLB;
      else                ehl = 0xFF;
      
      for ( hwlb=shl; hwlb<=ehl; hwlb++ )
      {
	 @Display 66, 9, hwlb;
	 @Out A [16..17] , hwlb;
	 
	 if (hwlb == S_HWLB) slh = S_LWHB;
         else                slh = 0;
         if (hwlb == E_HWLB) elh = E_LWHB;
         else                elh = 0xFF;

	 for ( lwhb=slh; lwhb<=elh; lwhb++)
         {
	    @Display 68, 9, lwhb;
	    @Out A [8..15], lwhb;   /* Output High word address */
	    
	    if (lwhb == S_LWHB) sll = S_LWLB;
            else                sll = 0;
            if (lwhb == E_LWHB) ell = E_LWLB;
            else                ell = 0xFF;

	    for ( lwlb=sll; lwlb<=ell; lwlb++)
	    {
	       @Out A [0..7], lwlb;    /* Low  byte address output */
	       
	       @Out CE      , @L;
	       @Out OE      , @L;
	       @In  D [0..15], tmp;
	       @Out CE	     , @H;
	       @Out OE      , @H;

	       if      (FUNCTION == Read)     
	       {
	            	@Load tmp;	/* Low Byte */
	       		@Inc	1;
	       		tmp >>= 8;	/*  High Byte */
	       		@Load tmp;
	       }
	       else if (FUNCTION == Blank_Check)   /* Blank_Char */
	       {
		    if (tmp != 0xFFFF)	Failf(hwhb, hwlb, lwhb, lwlb, tmp);
	       }
	       else if (FUNCTION == Verify)
	       {
		   @Store tmp2;
		   @Inc	1;
		   @Store tmp1;
		   tmp2 |= tmp1<<8;
		   if (tmp != tmp2)  Failf (hwhb, hwlb, lwhb, lwlb, tmp);
	       }
	       else if (FUNCTION == Data_Compare)
	       {
	       	    @Store	tmp2;
	       	    @Inc	1;
	       	    @Store	tmp1;
	       	    tmp2 |= tmp1<<8;
	       	    @Compare 	tmp, tmp2;
	       }	       
	       if ( FUNCTION !=Blank_Check )	@Inc incval;
            }
	 }
      }
   }
   if 	   (FUNCTION == Read)		@Display 26, row, "Read OK!   ";
   else if (FUNCTION == Verify)		@Display 26, row, "Verification OK!";
   else if (FUNCTION == Blank_Check)	@Display 26, row, "Blank Check OK!  ";
   else 			        @Display 26, row, "Data Comparison OK!";
}
/* -----------------------------------------------------------------------
 * program() ---> Control main
 * ----------------------------------------------------------------------- */
int	program (row, kind)
int	row, kind;
{
int  hwhb, hwlb, lwhb, lwlb;
int  sll, ell, slh, elh, shl, ehl;
int  tmp , tmp1, tmp2, failcnt, incval;

   failcnt = lwlb = lwhb = hwhb = hwlb = 0;
   sll = ell = slh = elh = shl = ehl = tmp = tmp1 = tmp2 = incval = 0;
   
   @Set  B_HADDR, B_LADDR;
   @Inc	__B_START__;
   
   if (SPLIT == 1)	incval = 1;
   else
   {
   	@Inc	__B_START__;
   	incval = SPLIT + 1;
   }
   
   @Display 26, row, "Programming...";      
   
   for ( hwhb=0 /* S_HWHB */; hwhb<=0 /* E_HWHB */; hwhb++ )
   {
       @Display 64, 9, hwhb;
       if (hwhb == S_HWHB) shl = S_HWLB;
       else                shl = 0;
       if (hwhb == E_HWHB) ehl = E_HWLB;
       else                ehl = 0xFF;       
       
       for ( hwlb=shl; hwlb<=ehl; hwlb++ )
       {
	   @Display 66, 9, hwlb;
	   @Out A[16..17], hwlb;
	   
	   if (hwlb == S_HWLB) slh = S_LWHB;
           else                slh = 0;
           if (hwlb == E_HWLB) elh = E_LWHB;
           else                elh = 0xFF;

	   for ( lwhb=slh; lwhb<=elh; lwhb++)
	   {
	       @Display 68, 9, lwhb;
	       @Out A [8..15], lwhb;   /* Output High word address */
	       
	       if (lwhb == S_LWHB) sll = S_LWLB;
               else                sll = 0;
               if (lwhb == E_LWHB) ell = E_LWLB;
               else                ell = 0xFF;

	       for ( lwlb=sll; lwlb<=ell; lwlb++)
	       {
		  @Store tmp;
		  @Inc	1;
		  @Store tmp1;
		  tmp |= tmp1<<8;
		  
		  if (tmp == 0xFFFF)
		  {
		     @Inc	incval;
		     continue;
		  }

	          @Out A [0..7]  , lwlb;
		  @Out D [0..15] , tmp;

		  @Out CE	, @L;
		  @Delay 50	, @us;
		  @Out CE	, @H;
		  
		  /* -------- One word Verify ----------- */
		  @Out D [0..15],  @Z;
		  @Out OE	, @L;
		  @Out CE	, @L;
		  @In  D [0..15], tmp2;

		  @Out CE	, @H;
		  @Out OE       , @H;
		  
		  @Out D [0..15], @W;		  
		  
		  if (tmp != tmp2)
                  {
		     if (failcnt > 25 ) Failf (hwhb, hwlb, lwhb, lwlb, tmp2);
		     else
		     {
			++ failcnt;
			lwlb--;
			@Dec	1;
		     }
                  }
		  else
		  {
			failcnt = 0;
			@Inc incval;
		  }
               }
	   }
       }
   }
   @Display 26, row, "Program OK!   ";
   if (kind == 0)	row = 7;
   else			row = 8;
   FUNCTION = Verify;
   @Vout 2	, 5.0;
   @Vout 3	, 5.0;
   read (row);		/*  Verify  */
}

/* -----------------------------------------------------------------------
 * main () ---> Control main
 * ----------------------------------------------------------------------- */
int main ()
{
   InitProcess();

   if ( FUNCTION == Auto )
   {
	FUNCTION = Blank_Check;
	read (6);

	FUNCTION = Program;
	InitProcess ();
	program(7, 1);
   }
   else if ( FUNCTION == Program ) program(6, 0);
   else 			   read (6);
}
/* ---------------------------- End of program --------------------------- */ 